%global with_doc %{!?_without_doc:1}%{?_without_doc:0}
%global pypi_name cinder
%global release_name liberty

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:             openstack-cinder
# Liberty semver reset
# https://review.openstack.org/#/q/I6a35fa0dda798fad93b804d00a46af80f08d475c,n,z
Epoch:            1
Version:          7.0.3
Release:          6%{?milestone}%{?dist}
Summary:          OpenStack Volume service

License:          ASL 2.0
URL:              http://www.openstack.org/software/openstack-storage/
Source0:          http://tarballs.openstack.org/%{pypi_name}/%{pypi_name}-%{upstream_version}.tar.gz

Source1:          cinder-dist.conf
Source2:          cinder.logrotate
Source3:          cinder-tgt.conf

Source10:         openstack-cinder-api.service
Source11:         openstack-cinder-scheduler.service
Source12:         openstack-cinder-volume.service
Source13:         openstack-cinder-backup.service
Source20:         cinder-sudoers

#patches_ignore=DROP-IN-RPM
#patches_base=+3
Patch0001: 0001-Remove-usr-local-from-rootwrap-config.patch
Patch0002: 0002-Capture-warnings-into-logs.patch
Patch0003: 0003-Remove-sqlite_clean_db-option.patch
Patch0004: 0004-rtstool-surrounds-IPv6-addresses-by-brackets.patch
Patch0005: 0005-Cleanup-volume_attachment-in-case-of-reset-state-att.patch
Patch0006: 0006-Log-terminate_connection-exception-with-traceback.patch
Patch0007: 0007-3par-driver-handles-concurrent-host-create-conflict.patch
Patch0008: 0008-Profiler-don-t-call-trace_cls-if-profiler-is-not-ena.patch
Patch0009: 0009-Profiler-make-it-possible-to-run-without-loading-osp.patch
Patch0010: 0010-NetApp-NFS-Look-for-new-file-for-60s.patch
Patch0011: 0011-RBD-Make-snapshot_delete-more-robust.patch
Patch0012: 0012-Fix-to-allow-RBD-delete-an-unprotected-snapshot.patch
Patch0013: 0013-RBD-delete-snapshots-if-missing-in-the-backend.patch
Patch0014: 0014-Remove-sleep-mocks-in-RBD-unit-tests.patch
Patch0015: 0015-RBD-prevent-creation-of-encrypted-volumes.patch
Patch0016: 0016-NetApp-NFS-Cmode-Fix-NotFound-exception.patch
Patch0017: 0017-Prevent-duplicate-entries-in-the-image-cache.patch
Patch0018: 0018-Handle-SSL-termination-proxies-for-version-list.patch

BuildArch:        noarch
BuildRequires:    intltool
BuildRequires:    python-d2to1
BuildRequires:    python-oslo-sphinx
BuildRequires:    python-pbr
BuildRequires:    python-sphinx
BuildRequires:    python2-devel
BuildRequires:    python-setuptools
BuildRequires:    python-netaddr
BuildRequires:    systemd
BuildRequires:    git
BuildRequires:    os-brick
BuildRequires:    python-oslo-concurrency
BuildRequires:    python-oslo-messaging
BuildRequires:    python-oslo-service
# Required to build cinder.conf
BuildRequires:    python-keystonemiddleware
BuildRequires:    python-glanceclient
BuildRequires:    python-novaclient
BuildRequires:    python-swiftclient
BuildRequires:    python-oslo-db
BuildRequires:    python-oslo-config >= 2:1.11.0
BuildRequires:    python-oslo-policy
BuildRequires:    python-oslo-reports
BuildRequires:    python-oslo-utils
BuildRequires:    python-oslo-versionedobjects
BuildRequires:    python-oslo-vmware
BuildRequires:    python-crypto
BuildRequires:    python-lxml
BuildRequires:    python-osprofiler
BuildRequires:    python-paramiko
BuildRequires:    python-suds
BuildRequires:    python-taskflow

Requires:         openstack-utils
Requires:         python-cinder = %{epoch}:%{version}-%{release}

# we dropped the patch to remove PBR for Delorean
Requires:         python-pbr

# as convenience
Requires:         python-cinderclient

Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd
Requires(pre):    shadow-utils

Requires:         lvm2
Requires:         python-osprofiler
Requires:         python-rtslib

%description
OpenStack Volume (codename Cinder) provides services to manage and
access block storage volumes for use by Virtual Machine instances.


%package -n       python-cinder
Summary:          OpenStack Volume Python libraries
Group:            Applications/System

Requires:         sudo

Requires:         MySQL-python

Requires:         qemu-img
Requires:         sysfsutils
Requires:         os-brick
Requires:         python-paramiko

Requires:         python-qpid
Requires:         python-kombu
Requires:         python-amqplib

Requires:         python-eventlet
Requires:         python-greenlet
Requires:         python-iso8601
Requires:         python-netaddr
Requires:         python-lxml
Requires:         python-anyjson
Requires:         python-cheetah
Requires:         python-stevedore
Requires:         python-suds

Requires:         python-sqlalchemy
Requires:         python-migrate

Requires:         python-paste-deploy
Requires:         python-routes
Requires:         python-webob

Requires:         python-glanceclient >= 1:1.1.0
Requires:         python-swiftclient >= 2.2.0
Requires:         python-keystoneclient >= 1.6.0
Requires:         python-novaclient >= 1:2.29

Requires:         python-oslo-config >= 1:1.2.0
# upstream states python-six >= 1.9.0
Requires:         python-six >= 1.5.0
Requires:         python-psutil >= 1.1.1

Requires:         python-babel
Requires:         python-lockfile
Requires:         python-jinja2

Requires:         python-oslo-rootwrap >= 2.0.0
# upstream states python-oslo-utils >= 3.2.0
Requires:         python-oslo-utils >= 2.5.0
# upstream states python-oslo-serialization >= 1.10.0
Requires:         python-oslo-serialization >= 1.9.0
# upstream states python-oslo-db >= 4.1.0
Requires:         python-oslo-db >= 2.6.0
Requires:         python-oslo-context
Requires:         python-oslo-concurrency >= 2.6.1
# upstream states python-oslo-middleware >= 3.0.0
Requires:         python-oslo-middleware >= 2.8.0-3%{?dist}
Requires:         python-taskflow >= 1.16.0
# upstream states python-oslo-messaging >= 2.6.1
Requires:         python-oslo-messaging >= 2.5.0
# upstream states python-keystonemiddleware >= 4.0.0
Requires:         python-keystonemiddleware >= 2.3.0
Requires:         python-oslo-policy
Requires:         python-oslo-reports >= 0.6.0
# upstream states python-oslo-service >= 1.0.0
Requires:         python-oslo-service >= 0.9.0
# upstream states python-oslo-versionedobjects >= 0.13.0
Requires:         python-oslo-versionedobjects >= 0.10.0
Requires:         libcgroup-tools
Requires:         iscsi-initiator-utils

Requires:         python-osprofiler

Requires:         pytz

%description -n   python-cinder
OpenStack Volume (codename Cinder) provides services to manage and
access block storage volumes for use by Virtual Machine instances.

This package contains the cinder Python library.

%if 0%{?with_doc}
%package doc
Summary:          Documentation for OpenStack Volume
Group:            Documentation

Requires:         %{name} = %{epoch}:%{version}-%{release}

BuildRequires:    graphviz

# Required to build module documents
BuildRequires:    python-eventlet
BuildRequires:    python-routes
BuildRequires:    python-sqlalchemy
BuildRequires:    python-webob
# while not strictly required, quiets the build down when building docs.
BuildRequires:    python-migrate, python-iso8601

%description      doc
OpenStack Volume (codename Cinder) provides services to manage and
access block storage volumes for use by Virtual Machine instances.

This package contains documentation files for cinder.
%endif

%prep
%autosetup -n cinder-%{upstream_version} -S git

find . \( -name .gitignore -o -name .placeholder \) -delete

find cinder -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
rm -rf {test-,}requirements.txt tools/{pip,test}-requires


%build
# Generate config file
rm -f %{_builddir}/cinder-%{version}/cinder/test.py
PYTHONPATH=. tools/config/generate_sample.sh from_tox

%{__python2} setup.py build

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# docs generation requires everything to be installed first
export PYTHONPATH="$( pwd ):$PYTHONPATH"

pushd doc

%if 0%{?with_doc}
SPHINX_DEBUG=1 sphinx-build -b html source build/html
# Fix hidden-file-or-dir warnings
rm -fr build/html/.doctrees build/html/.buildinfo
%endif

# Create dir link to avoid a sphinx-build exception
mkdir -p build/man/.doctrees/
ln -s .  build/man/.doctrees/man
SPHINX_DEBUG=1 sphinx-build -b man -c source source/man build/man
mkdir -p %{buildroot}%{_mandir}/man1
install -p -D -m 644 build/man/*.1 %{buildroot}%{_mandir}/man1/

popd

# Setup directories
install -d -m 755 %{buildroot}%{_sharedstatedir}/cinder
install -d -m 755 %{buildroot}%{_sharedstatedir}/cinder/tmp
install -d -m 755 %{buildroot}%{_localstatedir}/log/cinder

# Install config files
install -d -m 755 %{buildroot}%{_sysconfdir}/cinder
install -p -D -m 640 %{SOURCE1} %{buildroot}%{_datadir}/cinder/cinder-dist.conf
install -d -m 755 %{buildroot}%{_sysconfdir}/cinder/volumes
install -p -D -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/tgt/conf.d/cinder.conf
install -p -D -m 640 etc/cinder/rootwrap.conf %{buildroot}%{_sysconfdir}/cinder/rootwrap.conf
install -p -D -m 640 etc/cinder/api-paste.ini %{buildroot}%{_sysconfdir}/cinder/api-paste.ini
install -p -D -m 640 etc/cinder/policy.json %{buildroot}%{_sysconfdir}/cinder/policy.json
install -p -D -m 640 etc/cinder/cinder.conf.sample %{buildroot}%{_sysconfdir}/cinder/cinder.conf

# Install initscripts for services
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/openstack-cinder-api.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/openstack-cinder-scheduler.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/openstack-cinder-volume.service
install -p -D -m 644 %{SOURCE13} %{buildroot}%{_unitdir}/openstack-cinder-backup.service

# Install sudoers
install -p -D -m 440 %{SOURCE20} %{buildroot}%{_sysconfdir}/sudoers.d/cinder

# Install logrotate
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-cinder

# Install pid directory
install -d -m 755 %{buildroot}%{_localstatedir}/run/cinder

# Install rootwrap files in /usr/share/cinder/rootwrap
mkdir -p %{buildroot}%{_datarootdir}/cinder/rootwrap/
install -p -D -m 644 etc/cinder/rootwrap.d/* %{buildroot}%{_datarootdir}/cinder/rootwrap/


# Symlinks to rootwrap config files
mkdir -p %{buildroot}%{_sysconfdir}/cinder/rootwrap.d
for filter in %{_datarootdir}/os-brick/rootwrap/*.filters; do
ln -s $filter %{buildroot}%{_sysconfdir}/cinder/rootwrap.d/
done
# Remove unneeded in production stuff
rm -f %{buildroot}%{_bindir}/cinder-all
rm -f %{buildroot}%{_bindir}/cinder-debug
rm -fr %{buildroot}%{python2_sitelib}/cinder/tests/
rm -fr %{buildroot}%{python2_sitelib}/run_tests.*
rm -f %{buildroot}/usr/share/doc/cinder/README*

%pre
getent group cinder >/dev/null || groupadd -r cinder --gid 165
if ! getent passwd cinder >/dev/null; then
  useradd -u 165 -r -g cinder -G cinder,nobody -d %{_sharedstatedir}/cinder -s /sbin/nologin -c "OpenStack Cinder Daemons" cinder
fi
exit 0

%post
%systemd_post openstack-cinder-volume
%systemd_post openstack-cinder-api
%systemd_post openstack-cinder-scheduler
%systemd_post openstack-cinder-backup

%preun
%systemd_preun openstack-cinder-volume
%systemd_preun openstack-cinder-api
%systemd_preun openstack-cinder-scheduler
%systemd_preun openstack-cinder-backup

%postun
%systemd_postun_with_restart openstack-cinder-volume
%systemd_postun_with_restart openstack-cinder-api
%systemd_postun_with_restart openstack-cinder-scheduler
%systemd_postun_with_restart openstack-cinder-backup

%files
%dir %{_sysconfdir}/cinder
%config(noreplace) %attr(-, root, cinder) %{_sysconfdir}/cinder/cinder.conf
%config(noreplace) %attr(-, root, cinder) %{_sysconfdir}/cinder/api-paste.ini
%config(noreplace) %attr(-, root, cinder) %{_sysconfdir}/cinder/rootwrap.conf
%config(noreplace) %attr(-, root, cinder) %{_sysconfdir}/cinder/policy.json
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-cinder
%config(noreplace) %{_sysconfdir}/sudoers.d/cinder
%config(noreplace) %{_sysconfdir}/tgt/conf.d/cinder.conf
%{_sysconfdir}/cinder/rootwrap.d/
%attr(-, root, cinder) %{_datadir}/cinder/cinder-dist.conf

%dir %attr(0750, cinder, cinder) %{_localstatedir}/log/cinder
%dir %attr(0755, cinder, root) %{_localstatedir}/run/cinder
%dir %attr(0755, cinder, root) %{_sysconfdir}/cinder/volumes

%{_bindir}/cinder-*
%{_unitdir}/*.service
%{_datarootdir}/cinder
%{_mandir}/man1/cinder*.1.gz

%defattr(-, cinder, cinder, -)
%dir %{_sharedstatedir}/cinder
%dir %{_sharedstatedir}/cinder/tmp

%files -n python-cinder
%{?!_licensedir: %global license %%doc}
%license LICENSE
%{python2_sitelib}/cinder
%{python2_sitelib}/cinder-*.egg-info

%if 0%{?with_doc}
%files doc
%doc doc/build/html
%endif

%changelog
* Thu May 18 2017 Eric Harney <eharney@redhat.com> 1:7.0.3-6
- Add http_proxy_to_wsgi middleware (RHBZ #1451497)

* Thu Apr 13 2017 Alan Bishop <abishop@redhat.com> 1:7.0.3-5
- Prevent duplicate entries in the image cache (RHBZ #1377891)

* Fri Jan 13 2017 Eric Harney <eharney@redhat.com> 1:7.0.3-4
- NetApp NFS Cmode: Fix NotFound exception (RHBZ #1411963)

* Thu Dec 22 2016 Eric Harney <eharney@redhat.com> 1:7.0.3-3
- RBD: Prevent creation of encrypted volumes (RHBZ #1401587)

* Mon Dec 05 2016 Eric Harney <eharney@redhat.com> 1:7.0.3-2
- RBD: snapshot delete fixes (RHBZ #1399741)

* Thu Nov 17 2016 Eric Harney <eharney@redhat.com> 1:7.0.3-1
- Update to 7.0.3 (RHBZ #1396263)
- Netapp NFS: Look for new file for >60s (RHBZ #1386263)

* Thu Oct 13 2016 Eric Harney <eharney@redhat.com> 1:7.0.2-5
- osprofiler/Unicode fixes (RHBZ #1383899)
- Limit memory and CPU when running qemu-img info (RHBZ #1382556)

* Wed Sep 07 2016 Eric Harney <eharney@redhat.com> 1:7.0.2-4
- 3PAR: Handle concurrent create conflict (RHBZ #1368570)

* Thu Aug 04 2016 Eric Harney <eharney@redhat.com> 1:7.0.2-3
- Add ability to cleanup volume attachment w/ reset-state (RHBZ #1362682)
- Support https keystone CA checking in volume quotas (RHBZ #1334483)

* Mon Jun 06 2016 Eric Harney <eharney@redhat.com> 1:7.0.2-2
- Fix LVM driver iSCSI IPv6 attach (RHBZ #1336226)

* Tue Apr 19 2016 Eric Harney <eharney@redhat.com> 1:7.0.2-1
- Update to 7.0.2 (RHBZ #1328567)

* Tue Mar 15 2016 Eric Harney <eharney@redhat.com> 1:7.0.1-8
- Remove sqlite_clean_db test option (RHBZ#1317583)

* Wed Mar 09 2016 Eric Harney <eharney@redhat.com> 1:7.0.1-7
- Add size and copytruncate directives to logrotate (RHBZ#1309387)
- Remove oslotest build dependency (RHBZ#1314487)
- Capture warnings into logs (RHBZ#1313893)

* Tue Feb 09 2016 Eric Harney <eharney@redhat.com> 1:7.0.1-6
- Fix Cinder quota compatibility with Keystone v2 (RHBZ#1295576)

* Wed Jan 13 2016 Haïkel Guémar <hguemar@fedoraproject.org> - 1:7.0.1-5
- Revert switch to dynamic UID/GID allocation (RHBZ#1297580)

* Tue Jan 12 2016 Haïkel Guémar <hguemar@fedoraproject.org> - 1:7.0.1-4
- Switch to dynamic UID/GID allocation (RHBZ#1297580)

* Thu Jan 07 2016 Eric Harney <eharney@redhat.com> 1:7.0.1-3
- Add req on python-oslo-policy
- Change log directory to cinder:cinder ownership

* Tue Dec 22 2015 Eric Harney <eharney@redhat.com> 1:7.0.1-2
- Add minimum version requirements

* Tue Dec 22 2015 Haikel Guemar <hguemar@fedoraproject.org> 1:7.0.1-1
- Update to 7.0.1 (RHBZ#1293391)

* Wed Oct 28 2015 Jon Schlueter <jschluet@redhat.com> 1:7.0.0-2
- Add oslo-utils to BuildRequires for generating sample config

* Fri Oct 16 2015 Haikel Guemar <hguemar@fedoraproject.org> 1:7.0.0-1
- Update to upstream 7.0.0

* Wed Oct 07 2015 Haikel Guemar <hguemar@fedoraproject.org> 7.0.0-0.2.0rc2
- Update to upstream 7.0.0.0rc2

* Wed Sep 30 2015 Haikel Guemar <hguemar@fedoraproject.org> 7.0.0-0.1rc1
- Update to upstream 7.0.0.0rc1

* Wed Jun 17 2015 Haïkel Guémar <hguemar@fedoraproject.org> 2015.1.0-3
- Fix CVE-2015-1851 (RHBZ #1231822)

* Mon May 04 2015 Alan Pevec <alan.pevec@redhat.com> 2015.1.0-2
- update keystone_authtoken section in sample conf

* Thu Apr 30 2015 Alan Pevec <alan.pevec@redhat.com> 2015.1.0-1
- OpenStack Kilo release
